SystemOrganization addCategory: #IAN_simulation!

Morph subclass: #IAN_clock
	instanceVariableNames: 'myTime myJobs textTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:01'!
handlesMouseDown
^ true! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:35'!
initialize 
| |
super initialize .
"appearence"
self color: Color lightBrown .
textTime := StringMorph new contents: ( myTime asString) .
textTime position: (self position + (12@5)).
self addMorph: textTime.
myJobs := OrderedCollection  new.
myTime := 0
! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:04'!
mouseDown: evt
evt shiftPressed ifTrue: [ (self isStepping) ifTrue: [ self stopStepping  ] ifFalse: [ self startStepping  ] ]! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 21:25'!
myTime
^myTime ! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:28'!
ownTime: aTime 
myTime := aTime! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:34'!
setupJobat: aTime for: aReceiver selector: aSelectorString toGet: anArray 
myJobs addLast: ((IAN_job new) atTime: aTime give: aReceiver selector: aSelectorString message: anArray )! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 15:35'!
step
| toDoes |
myTime := myTime + 1.
textTime contents: ( myTime asString) .
(myTime > 10000) ifTrue: [ myTime := 0 ].
" now see if there are call backs to do"
toDoes := myJobs select: [  : aJob | (aJob actionTime = myTime)  ]. " find the ones due now"

toDoes do: [ : thisToDo | "send the actiontoDoes "
	thisToDo actionReceiver perform: (thisToDo actionSelector) with: (thisToDo actionMessage )   . "perform: with:"
	myJobs remove: thisToDo . ]! !

!IAN_clock methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 18:02'!
stepTime
 ^100 ! !

Morph subclass: #IAN_fieldMorph
	instanceVariableNames: 'numCCs numENs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:53'!
acceptDroppingMorph: aMorph event: evt 
| num |
self addMorph:  aMorph .
aMorph inField: true .
aMorph wiggle: 0 .
(aMorph class = IAN_CC) ifTrue: [  num := (self numCCs: (self  numCCs + 1))] .
(aMorph class = IAN_EN) ifTrue: [  num := (self numENs:  (self  numENs  + 1))] .
aMorph changeName: num.
" give its clock a randome number"
aMorph changeTime: 500 atRandom.
^true! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:14'!
hasNoPartsYet
numCCs := 0.
numENs  := 0
! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:14'!
numCCs
^numCCs! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:16'!
numCCs: aVal 
^numCCs := aVal! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:15'!
numENs
^numENs! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 20:16'!
numENs: aVal 
^numENs := aVal! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:52'!
repelsMorph: aMorph event: evt 
^ (self wantsDroppedMorph: aMorph event: evt) not! !

!IAN_fieldMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 15:03'!
wantsDroppedMorph: aMorph event: evt 
"^((aMorph class = IAN_EN) or: [ (aMorph class = IAN_CC) or: [aMorph class = IAN_stateMachine] ])"
^true "for testing time"
! !

Morph subclass: #IAN_partsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_partsMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:06'!
acceptDroppingMorph: aMorph event: evt 
self addMorph:  aMorph .
aMorph inField: false .
^true! !

!IAN_partsMorph methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:58'!
wantsDroppedMorph: aMorph event: evt 
| aClass |
aClass := aMorph class.
^((aClass = IAN_Node) or: [ (aClass = IAN_CC) or: [aClass = IAN_stateMachine ] ]).! !

BorderedMorph subclass: #IAN_Node
	instanceVariableNames: 'myName inField wiggle myClock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

IAN_Node subclass: #IAN_CC
	instanceVariableNames: 'myType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:43'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:46'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ 
							wiggle := 0.
							self startStepping.
							myClock startStepping.
							myClock
								setupJobat: (myClock myTime + 40) \\ 10000
								for: Transcript
								selector: 'show:'
								toGet: #('hello from CC') ] ]
				ifFalse: [ self findENs do: [ :anEN | self sendToEN: anEN message: 'hi' ] ] ]! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:44'!
myType
^ myType! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:44'!
myType: aString 
myType := aString! !

!IAN_CC methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:48'!
sendToEN: anEN message: aMessage
" send a basic message to a particular EN"
Transcript cr.
Transcript show: self myName, ' Sent to an EN called :- ',(anEN myName),' message :- ' ; show: aMessage ; cr! !

IAN_Node subclass: #IAN_EN
	instanceVariableNames: 'myType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:42'!
handlesMouseDown: evt 
(evt controlKeyPressed ) ifFalse: [ ^self inField ].
 ^true
! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 15:24'!
mouseDown: evt
	evt controlKeyPressed
		ifTrue: [ World primaryHand attachMorph: self copy ]
		ifFalse: [ 
			evt shiftPressed
				ifTrue: [ 
					inField
						ifTrue: [ 
							wiggle := 0.
							self startStepping.
							myClock startStepping.
							myClock
								setupJobat: (myClock myTime + 40) \\ 10000
								for: Transcript
								selector: 'show:'
								toGet: #('hello') ] ]
				ifFalse: [ self findCCs do: [ :aCC | self sendToCC: aCC message: 'sending...' ] ] ]! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:30'!
myType
^myType ! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:30'!
myType: aString 
myType := aString! !

!IAN_EN methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:31'!
sendToCC: aCC message: aMessage
| blob |
" send a basic message to a particular cc"
Transcript cr.
Transcript show: self myName, ' Sent to a CC called :- ',(aCC myName),' message :- ' ; show: aMessage ; cr.

" now send a small blob morph to the CC"
blob := IAN_message new.
self addMorphCentered: blob .
blob int: 1 ; color: Color blue.
blob extent: (8@8).
blob startPosition: self center.
blob targetPosition: aCC center.

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 11:55'!
acceptDroppingMorph: aMorph event: evt 
self addMorph:  aMorph .
aMorph position: (self position).
^true
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 14:34'!
changeName: aNum 
" use our name and add a counter (num) as a unique"
| subs t ourType|
ourType := self myType.
"find our text submorph"
subs := self submorphs .
subs isEmpty ifTrue:  [ "no name yet" 
					t := StringMorph new contents: (ourType asString,' ',aNum asString) . 
					self  addMorphCentered: t .
					
					self myName: (ourType asString,' ',aNum asString)
					]
		   ifFalse: [ "find the text morph and change its contents" 
					t := subs select: [  :aSubMorph | aSubMorph class = StringMorph  ].
					( t at: 1 ) contents:  (ourType asString,' ',aNum asString) .
					( t at: 1) center: (self center).
					self myName:  (ourType asString,' ',aNum asString) 
			         ]

! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:36'!
changeTime: aTime 
"tell our clock to get a new time"
myClock ownTime: aTime! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 19:54'!
extent: aPoint
"over ride for largest not smallest"
	| size oldRotationCenter |
	oldRotationCenter := self rotationCenter.
	size := aPoint x max: aPoint y.
	super extent: size @ size.
	self rotationCenter: oldRotationCenter.! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:35'!
findCCs
"ask my owner morph for the cc morphs"
| allCCs |

allCCs := self owner submorphs.
allCCs := allCCs select: [  :type | type class = IAN_CC ].

^allCCs ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:36'!
findENs
"ask my owner morph for the en morphs"
| allENS |

allENS := self owner submorphs.
allENS := allENS select: [  :type | type class = IAN_EN ].

^allENS ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 11:38'!
findMoreLikeYou
	self class = IAN_EN
		ifTrue: [ self findENs ]
		ifFalse: [ self findCCs ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:00'!
inField
^inField! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 23:09'!
inField: aBoolean 
inField := aBoolean! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 14:38'!
initialize
	| t pos |
	super initialize.
	self inField: false.
	pos := self position + (30 @ 39).
	myClock := IAN_clock new.
	myClock position: pos.
	myClock bounds: (pos extent: 45 @ 25).
	self addMorph: myClock.
	wiggle := 0.
	t := StringMorph new contents: (self class asString).
	self addMorphCentered: t! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/31/2014 20:12'!
myName
^myName! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 20:05'!
myName: aString

myName := aString .
^self ! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:57'!
repelsMorph: aMorph event: evt 
^ (self wantsDroppedMorph: aMorph event: evt) not! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 08:53'!
step
| leftright |
	"temp behavior"

	self inField
		ifTrue: [ 
			" here we can send PUSH"
			leftright := 1 .
			wiggle := wiggle + 1.
			wiggle timesRepeat: [ leftright := leftright * (-1) ].
			wiggle > 6
			ifTrue: [ self position: self position - (((leftright + 1) * 5) @ 0 ).
				    ^ self stopStepping
				 ].
			self position: self position + ( ( leftright * 5) @ 0) ]! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 08:16'!
stepTime
^60! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 23:35'!
wantsDroppedMorph: aMorph event: evt 
^((aMorph class = IAN_stateMachine)  and: [(self inField) and: [aMorph hasStates]] )
"^(((aMorph class) = IAN_stateMachine) )"
! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 16:46'!
wiggle
^wiggle! !

!IAN_Node methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 15:17'!
wiggle: aVal 
wiggle := aVal! !

CircleMorph subclass: #IAN_message
	instanceVariableNames: 'startPosition targetPosition int'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 20:35'!
initialize 
super initialize .

! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:24'!
int: aVal
int := aVal! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 16:48'!
startPosition
^startPosition! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 16:48'!
startPosition: aPos 
startPosition := aPos! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:21'!
startStepping
int := 1.
super startStepping ! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 22:36'!
step
	" go from present position towards target position in about 30 steps"
	(self position dist: targetPosition) > 10
		ifTrue: [ 
			self position: startPosition + ((targetPosition - startPosition) * int // 30).
			int := int + 1 ]
		ifFalse: [ 
			self stopStepping.
			self delete.
			Transcript show: 'Ive stopped'	"HERE i SHOULD KILL THE MORPH" ]! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:29'!
stepTime 
^30! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:35'!
targetPosition
^targetPosition! !

!IAN_message methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 14:34'!
targetPosition: aPosition 
targetPosition := aPosition ! !

CircleMorph subclass: #IAN_stateMachine
	instanceVariableNames: 'name states initialState inField ballonText hasStates aWheel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 21:43'!
aWheel: aVal 
^aWheel at: aVal! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:20'!
addState: aState 
states add: aState 
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 14:42'!
ballonText
^ballonText! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:43'!
ballonText: aString
ballonText := aString! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/2/2014 12:41'!
handlesMouseDown: evt 
^ ( inField not )! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:17'!
hasStates
^hasStates! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:49'!
hasStates: aBoolean 
hasStates := aBoolean ! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:01'!
inField
^inField! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 22:02'!
inField: aBol
inField:= aBol! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/3/2014 20:44'!
initialState: aState 
(states includes: aState ) ifTrue: [ initialState := aState ] ifFalse: [initialState := nil  ].
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/4/2014 21:44'!
initialize
super initialize .
self inField: false.
self ballonText: 'ballon test'.
self hasStates: false.
aWheel := Color lightCyan wheel: 8 .
! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:16'!
makeStateFrom: aFile 
| aStream f endPos startPos | 
" we read and parse the file into states"
"right now nothing"
self name: aFile.
"read the file into aString"
f := StandardFileStream 
	fileNamed: aFile  .
	
f findString: '<statechart' .
startPos := f position.
Transcript show:' ...STARTS at :- ' ; show: startPos ; cr .
endPos := f findStringFromEnd:  '</statechart>'.
endPos := endPos + ('</statechart>' size).
Transcript show:' ...ENDS at :- ' ; show: endPos ; cr .
" now put that in a String we can stream over"

f position: startPos.
aStream := OrderedCollection new writeStream .
[ f atEnd or: [ f position = endPos ] ] whileFalse: [ aStream nextPut: (f next)].
f close.
" lets deconstruct the state chart (in the aStream variable"
self parseStates: aStream.

self hasStates: true.! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 21:42'!
mouseDown: evt 
| aFile |
evt controlKeyPressed ifTrue: [ World primaryHand attachMorph: self copy . ] .

evt shiftPressed ifTrue: [
	aFile := (UIManager default chooseFileMatching: nil ).
	self makeStateFrom: aFile.
	self color: (self aWheel: (aFile asString stringhash \\ 8) + 1)]  .


! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:17'!
name
^name! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 1/28/2014 15:17'!
name: aString
name := aString.! !

!IAN_stateMachine methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 16:17'!
parseStates: anOrdedCollection
"at this point file has been read and ordered collection has the revelent parts"
! !

Object subclass: #IAN_Space
	instanceVariableNames: 'window fieldMorph partsMorph logMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_Space methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/5/2014 10:21'!
initialize 

super initialize.
window:=StandardWindow labelled: 'IAN_Space'.
fieldMorph := IAN_fieldMorph new.
window
      addMorph: fieldMorph
      fullFrame: (LayoutFrame
          fractions: (0@0 corner: 1@1)
          offsets: (100@0 corner: 0@125 negated)).
fieldMorph color: Color lightGray .
fieldMorph hasNoPartsYet.

partsMorph := IAN_partsMorph new.
window
      addMorph: partsMorph
      fullFrame: (LayoutFrame
          fractions: (0@0 corner: 0@1)
          offsets: (0@0 corner: 100@125 negated)).
partsMorph color: Color veryLightGray .

logMorph := IAN_logMorph new.
window
      addMorph: logMorph
      fullFrame: (LayoutFrame
          fractions: (0@1 corner: 1@1)
          offsets: (0@125 negated corner: 0@0)).
logMorph color: Color lightBlue .
  window openInWorld.
^self! !

!IAN_Space methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/7/2014 21:29'!
stage
| aCC anEN aStateMachine |
" this method places element on to the IAN space"
aCC := (IAN_CC new) .
aCC myType: 'CC' .
aCC stopStepping .
aCC color: Color lightRed ; borderWidth: 2 ; useRoundedCorners .

anEN := (IAN_EN new).
anEN myType: 'EN' .
anEN color: Color lightGreen ; borderWidth: 2 ;useRoundedCorners .

partsMorph addMorphCentered: aCC .
partsMorph addMorphCentered: anEN .
anEN position: (anEN position + (0@85)).

"now add state machine holders"
aStateMachine := (IAN_stateMachine new).
aStateMachine color: Color transparent  ; borderWidth: 2 ; extent: (15@15). 
partsMorph addMorphCentered: aStateMachine.
aStateMachine position: (aStateMachine position - (10@80)).
" second one to hold other machine"
aStateMachine := (IAN_stateMachine new).
aStateMachine color: Color transparent  ; borderWidth: 2 ; extent: (15@15). 
partsMorph addMorphCentered: aStateMachine.
aStateMachine position: (aStateMachine position - (-10@80)).

logMorph addMorph: (DockingBarMorph new 
	addMorph: (SimpleButtonMorph new
                                           label: 'Turn On Logging';
                                           target: [UIManager inform: 'Hello'];
                                           actionSelector: #value);
	addMorph: (SimpleButtonMorph new
                                           label: 'Say bonjour';
                                           target: [UIManager inform: 'Bonjour'];
                                           actionSelector: #value);
	addMorph: (SimpleButtonMorph new
                                           label: 'Close';
                                           target: [DockingBarMorph allInstances last delete];
                                           actionSelector: #value);
	adhereToBottom)

! !

Object subclass: #IAN_job
	instanceVariableNames: 'actionTime actionReceiver actionSelector actionMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:32'!
actionMessage
^actionMessage! !

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:31'!
actionReceiver
^actionReceiver! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 15:01'!
actionSelector
^actionSelector ! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:41'!
actionSelectorString: aStringToBeSymbol 
^aStringToBeSymbol  asSymbol! !

!IAN_job methodsFor: 'accessing' stamp: 'PhilipHunt 2/5/2014 18:29'!
actionTime
^actionTime ! !

!IAN_job methodsFor: 'as yet unclassified' stamp: 'PhilipHunt 2/6/2014 14:43'!
atTime: aTime give: aReceiver selector: aSelectorString message: anArray
actionTime :=aTime.
actionReceiver := aReceiver.
actionSelector := self actionSelectorString: aSelectorString. "converts to symbol for us"
actionMessage := anArray! !

Object subclass: #IAN_state
	instanceVariableNames: 'name transitions exit entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 13:40'!
addEntry: aBlock
entry := aBlock .
^entry! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 13:39'!
addExit: aBlock
exit := aBlock .
^exit! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 15:00'!
addTransition: aTransition toTarget: aState 
"each state can transition to another on conditions"
^transitions at: aTransition  put: aState.! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 14:41'!
initialize
transitions := Dictionary new.

^self ! !

!IAN_state methodsFor: 'initialize-release' stamp: 'PhilipHunt 1/28/2014 13:38'!
name
^name! !

!IAN_state methodsFor: 'actions' stamp: 'PhilipHunt 1/28/2014 13:29'!
name: aString
^name := aString
! !

!IAN_state methodsFor: 'actions' stamp: 'PhilipHunt 1/28/2014 14:49'!
transition: atransition
"answer a new state if the tranistion is good in this state"
| nextstate |
nextstate := transitions at: atransition ifAbsent: self .
^nextstate
! !

PluggableTextMorph subclass: #IAN_logMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IAN_simulation'!
